<?php

namespace eBizCharge\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEbizCustomField ArrayType
 * @subpackage Arrays
 */
class ArrayOfEbizCustomField extends AbstractStructArrayBase
{
    /**
     * The EbizCustomField
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \eBizCharge\StructType\EbizCustomField[]
     */
    public $EbizCustomField;
    /**
     * Constructor method for ArrayOfEbizCustomField
     * @uses ArrayOfEbizCustomField::setEbizCustomField()
     * @param \eBizCharge\StructType\EbizCustomField[] $ebizCustomField
     */
    public function __construct(array $ebizCustomField = array())
    {
        $this
            ->setEbizCustomField($ebizCustomField);
    }
    /**
     * Get EbizCustomField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \eBizCharge\StructType\EbizCustomField[]|null
     */
    public function getEbizCustomField()
    {
        return isset($this->EbizCustomField) ? $this->EbizCustomField : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEbizCustomField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEbizCustomField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEbizCustomFieldForArrayConstraintsFromSetEbizCustomField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEbizCustomFieldEbizCustomFieldItem) {
            // validation for constraint: itemType
            if (!$arrayOfEbizCustomFieldEbizCustomFieldItem instanceof \eBizCharge\StructType\EbizCustomField) {
                $invalidValues[] = is_object($arrayOfEbizCustomFieldEbizCustomFieldItem) ? get_class($arrayOfEbizCustomFieldEbizCustomFieldItem) : sprintf('%s(%s)', gettype($arrayOfEbizCustomFieldEbizCustomFieldItem), var_export($arrayOfEbizCustomFieldEbizCustomFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EbizCustomField property can only contain items of type \eBizCharge\StructType\EbizCustomField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EbizCustomField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\EbizCustomField[] $ebizCustomField
     * @return \eBizCharge\ArrayType\ArrayOfEbizCustomField
     */
    public function setEbizCustomField(array $ebizCustomField = array())
    {
        // validation for constraint: array
        if ('' !== ($ebizCustomFieldArrayErrorMessage = self::validateEbizCustomFieldForArrayConstraintsFromSetEbizCustomField($ebizCustomField))) {
            throw new \InvalidArgumentException($ebizCustomFieldArrayErrorMessage, __LINE__);
        }
        if (is_null($ebizCustomField) || (is_array($ebizCustomField) && empty($ebizCustomField))) {
            unset($this->EbizCustomField);
        } else {
            $this->EbizCustomField = $ebizCustomField;
        }
        return $this;
    }
    /**
     * Add item to EbizCustomField value
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\EbizCustomField $item
     * @return \eBizCharge\ArrayType\ArrayOfEbizCustomField
     */
    public function addToEbizCustomField(\eBizCharge\StructType\EbizCustomField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \eBizCharge\StructType\EbizCustomField) {
            throw new \InvalidArgumentException(sprintf('The EbizCustomField property can only contain items of type \eBizCharge\StructType\EbizCustomField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EbizCustomField[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \eBizCharge\StructType\EbizCustomField|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \eBizCharge\StructType\EbizCustomField|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \eBizCharge\StructType\EbizCustomField|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \eBizCharge\StructType\EbizCustomField|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \eBizCharge\StructType\EbizCustomField|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EbizCustomField
     */
    public function getAttributeName()
    {
        return 'EbizCustomField';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \eBizCharge\ArrayType\ArrayOfEbizCustomField
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
