<?php

namespace eBizCharge\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInvoicePaymentDetails ArrayType
 * @subpackage Arrays
 */
class ArrayOfInvoicePaymentDetails extends AbstractStructArrayBase
{
    /**
     * The InvoicePaymentDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \eBizCharge\StructType\InvoicePaymentDetails[]
     */
    public $InvoicePaymentDetails;
    /**
     * Constructor method for ArrayOfInvoicePaymentDetails
     * @uses ArrayOfInvoicePaymentDetails::setInvoicePaymentDetails()
     * @param \eBizCharge\StructType\InvoicePaymentDetails[] $invoicePaymentDetails
     */
    public function __construct(array $invoicePaymentDetails = array())
    {
        $this
            ->setInvoicePaymentDetails($invoicePaymentDetails);
    }
    /**
     * Get InvoicePaymentDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \eBizCharge\StructType\InvoicePaymentDetails[]|null
     */
    public function getInvoicePaymentDetails()
    {
        return isset($this->InvoicePaymentDetails) ? $this->InvoicePaymentDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInvoicePaymentDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInvoicePaymentDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInvoicePaymentDetailsForArrayConstraintsFromSetInvoicePaymentDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInvoicePaymentDetailsInvoicePaymentDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfInvoicePaymentDetailsInvoicePaymentDetailsItem instanceof \eBizCharge\StructType\InvoicePaymentDetails) {
                $invalidValues[] = is_object($arrayOfInvoicePaymentDetailsInvoicePaymentDetailsItem) ? get_class($arrayOfInvoicePaymentDetailsInvoicePaymentDetailsItem) : sprintf('%s(%s)', gettype($arrayOfInvoicePaymentDetailsInvoicePaymentDetailsItem), var_export($arrayOfInvoicePaymentDetailsInvoicePaymentDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InvoicePaymentDetails property can only contain items of type \eBizCharge\StructType\InvoicePaymentDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InvoicePaymentDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\InvoicePaymentDetails[] $invoicePaymentDetails
     * @return \eBizCharge\ArrayType\ArrayOfInvoicePaymentDetails
     */
    public function setInvoicePaymentDetails(array $invoicePaymentDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($invoicePaymentDetailsArrayErrorMessage = self::validateInvoicePaymentDetailsForArrayConstraintsFromSetInvoicePaymentDetails($invoicePaymentDetails))) {
            throw new \InvalidArgumentException($invoicePaymentDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($invoicePaymentDetails) || (is_array($invoicePaymentDetails) && empty($invoicePaymentDetails))) {
            unset($this->InvoicePaymentDetails);
        } else {
            $this->InvoicePaymentDetails = $invoicePaymentDetails;
        }
        return $this;
    }
    /**
     * Add item to InvoicePaymentDetails value
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\InvoicePaymentDetails $item
     * @return \eBizCharge\ArrayType\ArrayOfInvoicePaymentDetails
     */
    public function addToInvoicePaymentDetails(\eBizCharge\StructType\InvoicePaymentDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \eBizCharge\StructType\InvoicePaymentDetails) {
            throw new \InvalidArgumentException(sprintf('The InvoicePaymentDetails property can only contain items of type \eBizCharge\StructType\InvoicePaymentDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InvoicePaymentDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \eBizCharge\StructType\InvoicePaymentDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \eBizCharge\StructType\InvoicePaymentDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \eBizCharge\StructType\InvoicePaymentDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \eBizCharge\StructType\InvoicePaymentDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \eBizCharge\StructType\InvoicePaymentDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InvoicePaymentDetails
     */
    public function getAttributeName()
    {
        return 'InvoicePaymentDetails';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \eBizCharge\ArrayType\ArrayOfInvoicePaymentDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
