<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ModifyScheduledRecurringPayment_RecurringBilling
 * StructType
 * @subpackage Structs
 */
class ModifyScheduledRecurringPayment_RecurringBilling extends AbstractStructBase
{
    /**
     * The securityToken
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\StructType\SecurityToken
     */
    public $securityToken;
    /**
     * The scheduledPaymentInternalId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $scheduledPaymentInternalId;
    /**
     * The recurringBilling
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\StructType\RecurringBilling
     */
    public $recurringBilling;
    /**
     * Constructor method for ModifyScheduledRecurringPayment_RecurringBilling
     * @uses ModifyScheduledRecurringPayment_RecurringBilling::setSecurityToken()
     * @uses ModifyScheduledRecurringPayment_RecurringBilling::setScheduledPaymentInternalId()
     * @uses ModifyScheduledRecurringPayment_RecurringBilling::setRecurringBilling()
     * @param \eBizCharge\StructType\SecurityToken $securityToken
     * @param string $scheduledPaymentInternalId
     * @param \eBizCharge\StructType\RecurringBilling $recurringBilling
     */
    public function __construct(\eBizCharge\StructType\SecurityToken $securityToken = null, $scheduledPaymentInternalId = null, \eBizCharge\StructType\RecurringBilling $recurringBilling = null)
    {
        $this
            ->setSecurityToken($securityToken)
            ->setScheduledPaymentInternalId($scheduledPaymentInternalId)
            ->setRecurringBilling($recurringBilling);
    }
    /**
     * Get securityToken value
     * @return \eBizCharge\StructType\SecurityToken|null
     */
    public function getSecurityToken()
    {
        return $this->securityToken;
    }
    /**
     * Set securityToken value
     * @param \eBizCharge\StructType\SecurityToken $securityToken
     * @return \eBizCharge\StructType\ModifyScheduledRecurringPayment_RecurringBilling
     */
    public function setSecurityToken(\eBizCharge\StructType\SecurityToken $securityToken = null)
    {
        $this->securityToken = $securityToken;
        return $this;
    }
    /**
     * Get scheduledPaymentInternalId value
     * @return string|null
     */
    public function getScheduledPaymentInternalId()
    {
        return $this->scheduledPaymentInternalId;
    }
    /**
     * Set scheduledPaymentInternalId value
     * @param string $scheduledPaymentInternalId
     * @return \eBizCharge\StructType\ModifyScheduledRecurringPayment_RecurringBilling
     */
    public function setScheduledPaymentInternalId($scheduledPaymentInternalId = null)
    {
        // validation for constraint: string
        if (!is_null($scheduledPaymentInternalId) && !is_string($scheduledPaymentInternalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($scheduledPaymentInternalId, true), gettype($scheduledPaymentInternalId)), __LINE__);
        }
        $this->scheduledPaymentInternalId = $scheduledPaymentInternalId;
        return $this;
    }
    /**
     * Get recurringBilling value
     * @return \eBizCharge\StructType\RecurringBilling|null
     */
    public function getRecurringBilling()
    {
        return $this->recurringBilling;
    }
    /**
     * Set recurringBilling value
     * @param \eBizCharge\StructType\RecurringBilling $recurringBilling
     * @return \eBizCharge\StructType\ModifyScheduledRecurringPayment_RecurringBilling
     */
    public function setRecurringBilling(\eBizCharge\StructType\RecurringBilling $recurringBilling = null)
    {
        $this->recurringBilling = $recurringBilling;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \eBizCharge\StructType\ModifyScheduledRecurringPayment_RecurringBilling
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
